﻿package com.efg.games.notanks
{
	import flash.text.TextField;
	import com.efg.framework.FinalScoreScreen;
	import com.efg.framework.GameCompleteScreen;
	import com.efg.framework.GameOverScreen;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.geom.Point;
	
	import com.efg.framework.FrameWorkStates;
	import com.efg.framework.GameFrameWork;
	import com.efg.framework.BasicScreen;
	import com.efg.framework.BasicImageScreen;
	import com.efg.framework.ScoreBoard;
	import com.efg.framework.SideBySideScoreElement;
	import com.efg.framework.SoundManager;
	import com.efg.framework.StartScreen;
	import com.efg.framework.InfoScreen;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	
	public class Main extends GameFrameWork 
	{
		
		//game chapter background images
		//[Embed(source = '../../../../../assets/Chapter1.jpg')] 
		[Embed(source="../../../../../assets/Chapter1.png")]
		private var chapterClass1:Class;
		private var chap1:Bitmap = new chapterClass1;
		
		//[Embed(source = '../../../../../assets/Chapter2.jpg')]
		[Embed(source="../../../../../assets/Chapter2.png")]
		private var chapterClass2:Class;
		private var chap2:Bitmap = new chapterClass2;
		
		//[Embed(source = '../../../../../assets/Chapter3.jpg')]
		[Embed(source="../../../../../assets/Chapter3.png")]
		private var chapterClass3:Class;
		private var chap3:Bitmap = new chapterClass3;
		
		//[Embed(source = '../../../../../assets/Chapter4.jpg')]
		[Embed(source="../../../../../assets/Chapter4.png")]
		private var chapterClass4:Class;
		private var chap4:Bitmap = new chapterClass4;
		
		//[Embed(source = '../../../../../assets/Chapter5.jpg')]
		[Embed(source="../../../../../assets/Chapter5.png")]
		private var chapterClass5:Class;
		private var chap5:Bitmap = new chapterClass5;
		
		
		[Embed(source = "../../../../../assets/BludiskoStory.png")]
		private var storyClass1:Class;
		private var storyImage1:Bitmap = new storyClass1;
		
		[Embed(source = "../../../../../assets/BludiskoStory2.png")]
		private var storyClass2:Class;
		private var storyImage2:Bitmap = new storyClass2;
		
		[Embed(source = "../../../../../assets/BludiskoStory3.png")]
		private var storyClass3:Class;
		private var storyImage3:Bitmap = new storyClass3;
		
		[Embed(source = "../../../../../assets/BludiskoStory4.png")]
		private var storyClass4:Class;
		private var storyImage4:Bitmap = new storyClass4;
		
		[Embed(source="../../../../../assets/BludiskoStory5.png")]
		private var storyClass5:Class;
		private var storyImage5:Bitmap = new storyClass5;
		
		//custom sccore board elements
		public static const SCORE_BOARD_SCORE:String = "score";
		public static const SCORE_BOARD_TIME:String = "time";
		public static const SCORE_BOARD_ITEM1:String = "item1";
		public static const SCORE_BOARD_ITEM2:String = "item2";
		
		public static const SCORE_BOARD_TIMES1:String = "item1";
		public static const SCORE_BOARD_TIMES2:String = "item2";
		public static const SCORE_BOARD_COLLECTED:String = "collected";
		public static const SCORE_BOARD_TOTAL:String = "score";
		
	
		
		//custom sounds
		public static const SOUND_MENU:String = "soundmenu";
		public static const SOUND_INFO:String = "soundinfo";
		public static const SOUND_CHAPTER:String = "soundchapter";
		
		
		//item images that appear on game display
		//[Embed(source = '../../../../../assets/playerB.png')]
		[Embed(source="../../../../../assets/Diamond4.png")]
		private var itemHudImage:Class;
		private var itemHud1:Bitmap = new itemHudImage;
		
		[Embed(source = "../../../../../assets/TreasureChest.png")]
		private var itemHudImage2:Class;
		private var itemHud2:Bitmap = new itemHudImage2;
		
		
		
		// Our construction only calls init(). This way, we can re-init the entire system if necessary
		public function Main() 
		{
			init();
		}
		
		// init() is used to set up all of the things that we should only need to do one time
		override public function init():void 
		{
			game = new NoTanks();
			//game.y = 20;
			setApplicationBackGround(640, 500, false, 0xffffff);
			
			addChild(itemHud1);
			addChild(itemHud2);
			
			
			itemHud1.x = 10;
			itemHud1.y = 100;
			itemHud2.x = 10;
			itemHud2.y = 200;
			
			
			//add score board to the screen as the seconf layer
			scoreBoard = new ScoreBoard();
			addChild(scoreBoard);
			scoreBoardTextFormat= new TextFormat("_sans", "20", "0x000000", "true");
			
			scoreBoard.createTextElement(SCORE_BOARD_SCORE, new SideBySideScoreElement(10, 5, 50, "Score", scoreBoardTextFormat, 25, "0", scoreBoardTextFormat));
			scoreBoard.createTextElement(SCORE_BOARD_TIME, new SideBySideScoreElement(10, 50, 25, "Time", scoreBoardTextFormat, 25, "0", scoreBoardTextFormat));
			scoreBoard.createTextElement(SCORE_BOARD_ITEM1, new SideBySideScoreElement(60, 100, 0, "", scoreBoardTextFormat, 25, "0", scoreBoardTextFormat));
			scoreBoard.createTextElement(SCORE_BOARD_ITEM2, new SideBySideScoreElement(60, 200, 0, "", scoreBoardTextFormat, 25, "0", scoreBoardTextFormat));
			
			//screen text initializations
			screenTextFormat = new TextFormat("_sans", "16", "0xffffff", "false");
			screenTextFormat.align = flash.text.TextFormatAlign.CENTER;
			screenButtonFormat = new TextFormat("_sans", "12", "0x000000", "false");
			
			
			//the title screen, with some display text that can be removed
			titleScreen = new StartScreen(FrameWorkStates.STATE_SYSTEM_TITLE, 640,500,false,0x0000dd);
			titleScreen.createOkButton("Play", new Point(250, 450), 100, 20, screenButtonFormat, 0x000000, 0xff0000,2);
			
			
			
			//the story screen, with some display text that can be removed
			instructionsScreen = new InfoScreen(FrameWorkStates.STATE_SYSTEM_INSTRUCTIONS,640,500,false,0x0000dd);
			instructionsScreen.createOkButton("Start", new Point(250, 450), 100, 20,screenButtonFormat, 0x000000, 0xff0000,2);
			
		
			//game over screen
			gameOverScreen = new GameOverScreen(FrameWorkStates.STATE_SYSTEM_GAME_OVER,640,500,false,0x0000dd);
			//gameOverScreen.createDisplayText("Game Over", 100, new Point(250, 150), screenTextFormat);
			
			gameCompleteScreen = new GameCompleteScreen(FrameWorkStates.STATE_SYSTEM_GAME_COMPLETE, 640, 500, false, 0x0000dd);
			gameCompleteScreen.createOkButton("See Score", new Point(520, 10), 100, 20,screenButtonFormat, 0x000000, 0xff0000,2);
			
			
			//old school black screen that transitions between levels
			levelInScreen = new BasicScreen(FrameWorkStates.STATE_SYSTEM_LEVEL_IN, 640, 500, false, 0x000000);
			levelInText = "Level ";
			levelInScreen.createDisplayText(levelInText,100,new Point(250,150),screenTextFormat);
	
			
			//assign chapter images to chapters
			chapterScreen1 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_CHAPTER_SCREEN, 640, 500, chap1);
			chapterScreen1.createOkButton("Continue", new Point(250, 250), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2); 
			
			chapterScreen2 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_CHAPTER_SCREEN, 640, 500, chap2);
			chapterScreen2.createOkButton("Continue", new Point(250, 250), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			chapterScreen3 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_CHAPTER_SCREEN, 640, 500, chap3);
			chapterScreen3.createOkButton("Continue", new Point(250, 250), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			chapterScreen4 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_CHAPTER_SCREEN, 640, 500, chap4);
			chapterScreen4.createOkButton("Continue", new Point(250, 250), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			chapterScreen5 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_CHAPTER_SCREEN, 640, 500, chap5);
			chapterScreen5.createOkButton("Continue", new Point(250, 250), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			story1 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_INSTRUCTIONS, 640, 500, storyImage1);
			story1.createOkButton("Continue", new Point(520, 10), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			story2 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_INSTRUCTIONS, 640, 500, storyImage2);
			story2.createOkButton("Continue", new Point(520, 10), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			story3 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_INSTRUCTIONS, 640, 500, storyImage3);
			story3.createOkButton("Continue", new Point(520, 10), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			story4 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_INSTRUCTIONS, 640, 500, storyImage4);
			story4.createOkButton("Continue", new Point(520, 10), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			story5 = new BasicImageScreen(FrameWorkStates.STATE_SYSTEM_INSTRUCTIONS, 640, 500, storyImage5);
			story5.createOkButton("Continue", new Point(520, 10), 100, 20, screenButtonFormat, 0x000000, 0xff0000, 2);
			
			//set initial game state
			switchSystemState(FrameWorkStates.STATE_SYSTEM_TITLE);
			//switchSystemState(FrameWorkStates.STATE_SYSTEM_GAME_COMPLETE);
			
			//wait 
			waitTime = 30;
			
			//sounds
			soundManager.addSound(SOUND_INFO, new Library.SoundInfo);
			soundManager.addSound(SOUND_MENU, new Library.SoundMenu);
			soundManager.addSound(SOUND_CHAPTER, new Library.SoundChapter);
			
			//create timer and run it one time
			frameRate = 30;
			startTimer();	
		}
		
		//play sound at this screen and call the systemTitle function in gameFrameWork
		override public function systemTitle():void {
			soundManager.playSound(SOUND_MENU, false,999, 0, 1);
			super.systemTitle();
		}
		
		/*//play sound at this screen and call the systemInstructions function in gameFrameWork
		override public function systemInstructions():void {
			//soundManager.stopSound(SOUND_MENU);
			//soundManager.playSound(SOUND_INFO, false, 999, 0, 1);
			//super.systemInstructions();
		}
		
		//play sound at this screen and call the systemChapter function in gameFrameWork
		override public function systemChapter():void {
			//soundManager.stopSound(SOUND_INFO);
			//soundManager.playSound(SOUND_CHAPTER, false, 1, 0, 1);
			//super.systemChapter();
		}*/
		
		//play sound at this screen and call the systemNewGame function in gameFrameWork
		override public function systemNewGame():void {
			//soundManager.stopSound(SOUND_INFO);
			super.systemNewGame();
		}

		override public function systemScoreScreen():void 
		{
			/*
			removeChild(scoreBoard);
			
			finalScoreBoard = new ScoreBoard();
			addChild(finalScoreBoard);
			
			finalScoreBoard.createTextElement(SCORE_BOARD_COLLECTED, new SideBySideScoreElement(270, 50, 40, "Collected:", scoreBoardTextFormat, 25, "", scoreBoardTextFormat));
			finalScoreBoard.createTextElement(SCORE_BOARD_TIMES1, new SideBySideScoreElement(290, 145, 0, " x ", scoreBoardTextFormat, 25, "0", scoreBoardTextFormat));
			finalScoreBoard.createTextElement(SCORE_BOARD_TIMES2, new SideBySideScoreElement(290, 325, 0, " x ", scoreBoardTextFormat, 25, "0", scoreBoardTextFormat));
			finalScoreBoard.createTextElement(SCORE_BOARD_TOTAL, new SideBySideScoreElement(180, 425, 50, "Score = ", scoreBoardTextFormat, 55, "0", scoreBoardTextFormat));
			
			itemHud1.height = 80;
			itemHud1.width = 80;
			
			itemHud1.x = 180;
			itemHud1.y = 120;
			
			itemHud2.height = 80;
			itemHud2.width = 80;
			
			itemHud2.x = 180;
			itemHud2.y = 300;
			*/
			super.systemScoreScreen();
			
		}
	}
}	
		
		
		