﻿package com.efg.games.notanks
{
	//timer imported to track time
	import com.efg.framework.ScoreBoard;
	import flash.text.TextField;
	import flash.utils.Timer;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.*;
	import com.efg.framework.CustomEventSound;
	import com.efg.framework.Game;
	import com.efg.framework.CustomEventLevelScreenUpdate;
	import com.efg.framework.CustomEventScoreBoardUpdate;
	import com.efg.framework.CustomEventSound;
	import com.efg.framework.BlitSprite;
	import com.efg.framework.TileByTileBlitSprite;
	import com.efg.framework.TileSheet;
	import com.efg.framework.SideBySideScoreElement;
	
	
	/**
	 * ...
	 * @author Jeff Fulton
	 */
	public class NoTanks extends Game
	{
		//Maze code and variables//////////////////////////////////////////////////////////////////////////////////////////////////
		///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// maze width and height, in cells
		public var maze_width:int = 6;
		public var maze_height:int = 6;
		// wall size, in pixels
		public var wall_size:int = 80;
		// array that will contain maze information
		public var maze:Array = new Array();
		// array to keep track of my moves
		public var my_moves:Array = new Array();
		// sprite to visually display the maze
		public var maze_draw:Sprite = new Sprite();
		
		
		public function as3maze():void
		{
			
			
			// determining the number of cells in the maze
			var cell_count:int = maze_width*maze_height;
			// random starting position
			var pos:int = Math.floor(Math.random() * cell_count);
			// I am on a cell, so I visited one. Let's count visited cells...
			var visited:int = 1;
			for (var i:int = 0; i<cell_count; i++) {
				// this array contains VISITED (0 = not visited), NORTH WALL (1=up;0=down), SOUTH WALL, EAST WALL, WEST WALL
				maze[i]=new Array(0,1,1,1,1);
			}
			// marking the cell I am on as visited
			maze[pos][0]=1;
			// loop to be executed until all cells have been visited
			while (visited<cell_count) {
				// check for possible moves
				var possible:String = "";
				// possible move at west
				if ((Math.floor(pos/maze_width) == Math.floor((pos-1)/maze_width)) && (maze[pos-1][0] == 0)) {
					possible=possible+"W";
				}
				// possible move at east
				if ((Math.floor(pos/maze_width) == Math.floor((pos+1)/maze_width)) && (maze[pos+1][0] == 0)) {
					possible=possible+"E";
				}
				// possible move at south
				if (((pos+maze_width)<cell_count) && (maze[pos+maze_width][0] == 0)) {
					possible=possible+"S";
				}
				// possible move at north
				if (((pos-maze_width)>=0) && (maze[pos-maze_width][0] == 0)) {
					possible=possible+"N";
				}
				// if a move exists, crash a wall && mark new cell as visited     
				if (possible) {
					// increasing number of visited cells
					visited++;
					// saving my position the moves array
					my_moves.push(pos);
					// choosing a random direction
					var way:String = possible.charAt(Math.floor(Math.random()*possible.length));
					switch (way) {
						case "N" :
							// going north: crashing walls and updating position
							maze[pos][1]=0;
							maze[pos-maze_width][2]=0;
							pos-=maze_width;
							break;
						case "S" :
							// going south: crashing walls and updating position
							maze[pos][2]=0;
							maze[pos+maze_width][1]=0;
							pos+=maze_width;
							break;
						case "E" :
							// going east: crashing walls and updating position
							maze[pos][3]=0;
							maze[pos+1][4]=0;
							pos++;
							break;
						case "W" :
							// going west: crashing walls and updating position
							maze[pos][4]=0;
							maze[pos-1][3]=0;
							pos--;
							break;
					}
					// set the cell as visited
					maze[pos][0]=1;
					// if I cannot movie anymore, backtrack to a previously saved cell
				} else {
					pos=my_moves.pop();
				}
			}
			// start of maze drawing routine
			addChild(maze_draw);
			// black line
			maze_draw.graphics.lineStyle(2);
			maze_draw.graphics.moveTo(10,10);
			var start_y:int = 10 - wall_size;
			var start_x:int = 140;
			// drawing walls: I only draw east and south walls, because a cell's south wall is southern cell's north wall
			// and same thing for the east/west ones
			for (i=0; i<cell_count; i++) {
				start_x+=wall_size;
				if ((i%maze_width) == 0) {
					start_y+=wall_size;
					start_x=140;
				}
				if (maze[i][2]==1) {
					// south
					maze_draw.graphics.moveTo(start_x,start_y+wall_size);
					maze_draw.graphics.lineTo(start_x+wall_size,start_y+wall_size);
				}
				if (maze[i][3]==1) {
					// east
					maze_draw.graphics.moveTo(start_x+wall_size,start_y);
					maze_draw.graphics.lineTo(start_x+wall_size,start_y+wall_size);
				}
			}
			// red line for maze border
			maze_draw.graphics.lineStyle(2,0x000000);
			maze_draw.graphics.moveTo(140,10/*10,10*/);
			maze_draw.graphics.lineTo(140+wall_size*maze_width,10);
			maze_draw.graphics.lineTo(140+wall_size*maze_width,10+wall_size*maze_height);
			maze_draw.graphics.lineTo(140,10+wall_size*maze_height);
			maze_draw.graphics.lineTo(140, 10);
			
			
		}
		
		//maze code end///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		//[Embed(source = '../../../../../assets/chest1.png')]
		[Embed(source = "../../../../../assets/Diamond4.png")]
		private var itemImage:Class;
		private var chest1:Bitmap = new itemImage;
		private var chest2:Bitmap = new itemImage;
		
		[Embed(source="../../../../../assets/TreasureChest.png")]
		private var itemImage2:Class;
		private var chest3:Bitmap = new itemImage2;
		private var chest4:Bitmap = new itemImage2;
		private var chest5:Bitmap = new itemImage2;
		
		//[Embed(source = "../../../../../assets/Down-Left-Stairs.png")]
		[Embed(source="../../../../../assets/Exit2.png")]
		private var levelGoal:Class;
		private var goal:Bitmap = new levelGoal;
		
		[Embed(source="../../../../../assets/player.png")]
		private var playerImage:Class;
		private var player:Bitmap = new playerImage;
		
		//currentChapter
		private var chapterNumber:int = 1;
		
		//players current location in the maze
		private var mazeSpace:int = 0;
		
		//if the current level has been completed
		private var levelComplete:Boolean;
		
		//total number of items collected
		private var itemsCollected:int = 0;
		
		//walls of the curent maze square
		private static const TOP_WALL:int = 1;
		private static const BOTTOM_WALL:int = 2;
		private static const RIGHT_WALL:int = 3;
		private static const LEFT_WALL:int = 4;
		
		//countDown between Inputs
		private var upTimer:int = 0;
		private var downTimer:int = 0;
		private var leftTimer:int = 0;
		private var rightTimer:int = 0;
		
		
		//timer declaration and countdown function//////////////////////////////////////////////////////////////////////////////////
		public var gameTimer:Timer = new Timer(1000);
		public function countDown(event:TimerEvent):void
		{
			time -= 1;
		}
		
		//the level the player is currently on in the 
		private var level:int = 0;
	
		//*** added in iteration #2
		private var keyPressList:Array = [];
		
		
		//game specific
		private var score:int = 0;
		private var time:int;
		
		private var item1:int = 0;
		private var item2:int = 0;
		
		
		//game loop
		private var gameOver:Boolean = false;
		
		//goal
		//private var goalReached:Boolean = false;
		
		
		public function NoTanks() 
		{
			init();
			
		}
		
		private function init():void 
		{
			this.focusRect = false;
		}
		
	
		override public function newGame():void 
		{
			//timer stuff///////////////////////////////
			gameTimer.addEventListener(TimerEvent.TIMER, countDown); 
			
			addChild(chest1);
			addChild(chest2);
			addChild(chest3);
			addChild(chest4);
			addChild(chest5);
			
			addChild(player);
			
			addChild(goal);
			
			chest1.x = -10000;
			chest2.x = -10000;
			chest3.x = -10000;
			chest4.x = -10000;
			chest5.x = -10000;
			
			//can be removed
			gameOver = false;
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownListener);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpListener);

			
			dispatchEvent(new CustomEventScoreBoardUpdate(CustomEventScoreBoardUpdate.UPDATE_TEXT,Main.SCORE_BOARD_SCORE,"0"));
			dispatchEvent(new CustomEventScoreBoardUpdate(CustomEventScoreBoardUpdate.UPDATE_TEXT, Main.SCORE_BOARD_TIME, "0"));
			
		}
		
		override public function newLevel():void 
		{
			//used to reset things in new game, must be changed from this old code 
			stage.focus = this;
			var newGameStart:Boolean;
			if (level == 0) {
				newGameStart = true;
			}else {
				newGameStart = false;
			}
			
			//move or reset player starting location in maze
			mazeSpace = 0;
			levelComplete = false;
			
			player.x = 141.5;
			player.y = 11.5;
			
			switch (chapterNumber)
			{
				case 1:
					maze_height = 8;
					maze_width = 8;
					wall_size = 60;
					time = 20;
			
					goal.x = 141.5 + (maze_width - 1) * wall_size;
					goal.y = 11.5 + (maze_height - 1) * wall_size;
					
					chest1.x = Math.round(Math.random() * (maze_width - 1)) * wall_size + 141.5;
					chest1.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					break;
					
				case 2:
					maze_height = 10;
					maze_width = 10;
					wall_size = 48;
					time = 35;
					
					goal.x = 141.5 + (maze_width - 1) * wall_size;
					goal.y = 11.5 + (maze_height - 1) * wall_size;
					
					chest1.x = Math.round(Math.random() * (maze_width - 1)) * wall_size + 141.5;
					chest1.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					
					chest2.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest2.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					break;
					
				case 3:
					maze_height = 12;
					maze_width = 12;
					wall_size = 40;
					time = 50;
					
					goal.x = 141.5 + (maze_width - 1) * wall_size;
					goal.y = 11.5 + (maze_height - 1) * wall_size;
					
					chest1.x = Math.round(Math.random() * (maze_width - 1)) * wall_size + 141.5;
					chest1.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					
					chest2.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest2.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					
					chest3.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest3.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					break;
						
				case 4:
					maze_height = 16;
					maze_width = 16;
					wall_size = 30;
					time = 60;
					
					goal.x = 141.5 + (maze_width - 1) * wall_size;
					goal.y = 11.5 + (maze_height - 1) * wall_size;
					
					chest1.x = Math.round(Math.random() * (maze_width - 1)) * wall_size + 141.5;
					chest1.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					
					chest2.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest2.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					
					chest3.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest3.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					
					chest4.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest4.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					break;
						
				case 5:
					maze_height = 20;
					maze_width = 20;
					wall_size = 24;
					time = 90;
					
					goal.x = 141.5 + (maze_width - 1) * wall_size;
					goal.y = 11.5 + (maze_height - 1) * wall_size;
			
					chest1.x = Math.round(Math.random() * (maze_width - 1)) * wall_size + 141.5;
					chest1.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
				
					chest2.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest2.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
				
					chest3.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest3.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
				
					chest4.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest4.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;		
				
					chest5.x = Math.round(Math.random() * (maze_width - 1))* wall_size + 141.5;
					chest5.y = Math.round(Math.random() * (maze_height - 1)) * wall_size + 11.5;
					break;
					
			}
		
			//scale goal to maze size
			goal.height = wall_size - 4;
			goal.width = wall_size - 4;
			
			//scale player to maze size 
			player.height = wall_size - 4;
			player.width = wall_size - 4;
			//scale chests to maze size
			chest1.height = wall_size - 4;
			chest1.width = wall_size - 4;
			chest2.height = wall_size - 4;
			chest2.width = wall_size - 4;
			chest3.height = wall_size - 4;
			chest3.width = wall_size - 4;
			chest4.height = wall_size - 4;
			chest4.width = wall_size - 4;
			chest5.height = wall_size - 4;
			chest5.width = wall_size - 4;
			
			//create a maze
			as3maze();
			level++;
			
			dispatchEvent(new CustomEventLevelScreenUpdate(CustomEventLevelScreenUpdate.UPDATE_TEXT, String(level)));
	
		}
		
		
		//update scoreboard elements
		private function updateScoreBoard():void
		{
			dispatchEvent(new CustomEventScoreBoardUpdate(CustomEventScoreBoardUpdate.UPDATE_TEXT, Main.SCORE_BOARD_SCORE, String(score)));
			dispatchEvent(new CustomEventScoreBoardUpdate(CustomEventScoreBoardUpdate.UPDATE_TEXT, Main.SCORE_BOARD_TIME, String(time)));	
			dispatchEvent(new CustomEventScoreBoardUpdate(CustomEventScoreBoardUpdate.UPDATE_TEXT, Main.SCORE_BOARD_ITEM1, String(item1)));
			dispatchEvent(new CustomEventScoreBoardUpdate(CustomEventScoreBoardUpdate.UPDATE_TEXT, Main.SCORE_BOARD_ITEM2, String(item2)));
		}
		
		

		override public function runGame():void 
		{
			
			update();
			checkCollisions();		
			resetInputTracking();					
			
			//timer start/////////////////////////////////////////
			gameTimer.start();
			
			checkforEndLevel();
			checkforEndGame();
			updateScoreBoard();
		}
		
		
		
		private function checkforEndGame():void 
		{
			if (time == 0) 
			{
				dispatchEvent(new Event(GAME_OVER));
			}
		}
		
		
		
		private function checkforEndLevel():void 
		{
			
			if (levelComplete) 
			{
				//disposeAll();
				
				//remove the last maze from the screen
				removeChild(maze_draw);
				maze_draw = new Sprite;
				
				if (level % 5 == 0)
				{
					chapterNumber++;
				}
				
				dispatchEvent(new Event(NEW_LEVEL));
			}
			
		}
		
		public override function scoreScreen():void
		{
			removeChild(player);
			removeChild(chest1);
			removeChild(chest2);
			removeChild(chest3);
			removeChild(chest4);
			removeChild(chest5);
			removeChild(goal);
		}
		
		private function addToScore(val:Number):void 
		{
			score += val;
		}
		
		//currently unused code/////////////////////////////////////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		private function dispose(object:BlitSprite):void 
		{
			object.dispose();
			removeChild(object);
		}
		
		
		private function keyDownListener(e:KeyboardEvent):void 
		{
			keyPressList[e.keyCode]=true;	
		}
		
		
		private function keyUpListener(e:KeyboardEvent):void 
		{
			keyPressList[e.keyCode]=false;
		}
		
		private function update():void 
		{
			//move up
			if ( keyPressList[38])
			{
				upTimer++;
				
				if (maze[mazeSpace][TOP_WALL] == 0 && (upTimer == 1 || upTimer > 6))
				{
					player.y -= wall_size;
					mazeSpace -= maze_width;
				}
			}
			//move down
			else if ( keyPressList[40])
			{
				downTimer++;
				
				if (maze[mazeSpace][BOTTOM_WALL] == 0 && (downTimer == 1 || downTimer > 6))
				{
					player.y += wall_size;
					mazeSpace += maze_width;
				}
			}
			//move right
			else if ( keyPressList[39])
			{
				rightTimer++;
				
				if (maze[mazeSpace][RIGHT_WALL] == 0 && (rightTimer == 1 || rightTimer > 6))
				{
					player.x += wall_size;
					mazeSpace++;
				}
			}
			//move left
			else if ( keyPressList[37])
			{
				leftTimer++;
				
				if (maze[mazeSpace][LEFT_WALL] == 0 && (leftTimer == 1 || leftTimer > 6))
				{
					player.x -= wall_size;
					mazeSpace--;
				}
				
			}
			
			
			
		}
		
		
		private function checkCollisions():void 
		{
			
				if (player.x == chest1.x && player.y == chest1.y)
				{
					itemsCollected++;
					score += 10;
					chest1.y = -10000;
					item1++;
				}
				
				if (player.x == chest2.x && player.y == chest2.y)
				{
					itemsCollected++;
					score += 10;
					chest2.y = -10000;
					item1++;
				}
				
				if (player.x == chest3.x && player.y == chest3.y)
				{
					itemsCollected++;
					score += 10;
					chest3.y = -10000;
					item2++;
				}
				
				if (player.x == chest4.x && player.y == chest4.y)
				{
					itemsCollected++;
					score += 10;
					chest4.y = -10000;
					item2++;
				}
				
				if (player.x == chest5.x && player.y == chest5.y)
				{
					itemsCollected++;
					score += 10;
					chest5.y = -10000;
					item2++;
				}
				
				if (mazeSpace == maze_width * (maze_height - 1) + (maze_height - 1))//(mazeSpace == 1 || mazeSpace == maze_width )
				{
					score += time;
					levelComplete = true;
				}
		
				
		}
		
		
		
		private function resetInputTracking():void 
		{
			
			//reset up key tracking
			if (!keyPressList[38])
			{
				upTimer = 0;
			}
			
			//reset down key tracking
			if (!keyPressList[40])
			{
				downTimer = 0;
			}
			
			//reset right key tracking
			if (!keyPressList[39])
			{
				rightTimer = 0;
			}
			
			//reset left key tracking
			if (!keyPressList[37])
			{
				leftTimer = 0;
			}
		}
		
		
	}
	
}